package com.karza.aadhaarxmlsdk.flutter_aadhaar_xml_sdk;



import static android.app.Activity.RESULT_OK;
import static androidx.core.app.ActivityCompat.startActivityForResult;


import android.app.Activity;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.util.Log;

import androidx.annotation.NonNull;

import com.google.gson.Gson;
import com.karza.aadhaarsdk.AadharActivity;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;


import android.util.Log;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import android.app.Activity; // add this

import io.flutter.embedding.android.FlutterActivity;
import io.flutter.embedding.engine.FlutterEngine;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry;

/** FlutterAadhaarXmlSdkPlugin */
public class FlutterAadhaarXmlSdkPlugin implements FlutterPlugin, MethodCallHandler,ActivityAware, PluginRegistry.ActivityResultListener{
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;
  private String karzaToken, clientName;
  private  String env;
  private static final String TAG = "FlutterAadhaarXmlSdkPlugin";
  private Activity activity;
  private  Result result;



  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "flutter_aadhaar_xml_sdk");
    channel.setMethodCallHandler(this);
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    this.result = result;

    switch (call.method){

      case "startSdk":
        karzaToken =call.argument("token").toString();
        env =   call.argument("env").toString();
        clientName =  call.argument("client").toString();
        startSdk();
        break;
      default:
        result.notImplemented();
        break;
    }

  }



  public enum EnvType {
    PRODUCTION("prod"),
    ALPHA("alpha"),
    BETA("beta"),
    DEV("dev"),
    TEST("test");
    public String env;
    EnvType(String env) {
      this.env = env;
    }
  }


  private void startSdk() {
//    Intent intent = new Intent(activity, AadharActivity.class);
    Intent intent = new Intent(activity, AadharActivity.class);
    intent.putExtra("KARZA-TOKEN", karzaToken);
    intent.putExtra("ENV", env);
    intent.putExtra("CLIENT", clientName);
    activity.startActivityForResult(intent, 100);
  }

  @Override
  public boolean onActivityResult(int requestCode, int resultCode, Intent data) {

    if (resultCode == RESULT_OK && requestCode == 100) {

      Bundle bundle = data.getExtras();
      if (bundle != null) {
        Gson gson = new Gson();
        try {
          JSONObject jsonObj = new JSONObject(getJson(bundle));
          Log.e("data_fetched",jsonObj.toString());
          Map<Object, Object> map = new Gson().fromJson(jsonObj.toString(), HashMap.class);
          Log.e("data_fetched",map.toString());
          result.success(map);

        } catch (Exception ex) {
          ex.printStackTrace();
        }


      }
      return true;
    }
    return false;
  }


  /* get bundle to json data (Start)*/
  public static String getJson(final Bundle bundle) {
    if (bundle == null) return null;
    JSONObject jsonObject = new JSONObject();

    for (String key : bundle.keySet()) {
      Object obj = bundle.get(key);
      try {
        jsonObject.put(key, wrap(bundle.get(key)));
      } catch (JSONException e) {
        e.printStackTrace();
      }
    }
    return jsonObject.toString();
  }

  private static Object wrap(Object object) {
    if (object == null) {
      return JSONObject.NULL;
    }
    if (object instanceof JSONArray || object instanceof JSONObject) {
      return object;
    }
    if (object.equals(JSONObject.NULL)) {
      return object;
    }
    try {
      if (object instanceof Collection) {
        return new JSONArray((Collection) object);
      } else if (object.getClass().isArray()) {
        return toJSONArray(object);
      }
      if (object instanceof Map) {
        return new JSONObject((Map) object);
      }
      if (object instanceof Boolean ||
              object instanceof Byte ||
              object instanceof Character ||
              object instanceof Double ||
              object instanceof Float ||
              object instanceof Integer ||
              object instanceof Long ||
              object instanceof Short ||
              object instanceof String) {
        return object;
      }
      if (object.getClass().getPackage().getName().startsWith("java.")) {
        return object.toString();
      }
    } catch (Exception ignored) {
    }
    return null;
  }


  private static JSONArray toJSONArray(Object array) throws JSONException {
    JSONArray result = new JSONArray();
    if (!array.getClass().isArray()) {
      throw new JSONException("Not a primitive array: " + array.getClass());
    }
    final int length = Array.getLength(array);
    for (int i = 0; i < length; ++i) {
      result.put(wrap(Array.get(array, i)));
    }
    return result;
  }


  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }

  @Override
  public void onAttachedToActivity(@NonNull ActivityPluginBinding binding) {
    activity = binding.getActivity();
    binding.addActivityResultListener(this);
  }

  @Override
  public void onDetachedFromActivityForConfigChanges() {
    activity = null;
  }

  @Override
  public void onReattachedToActivityForConfigChanges(@NonNull ActivityPluginBinding binding) {
    activity = binding.getActivity();
    binding.addActivityResultListener(this);
  }

  @Override
  public void onDetachedFromActivity() {
    activity = null;
  }

}
