import 'dart:async';
import 'dart:collection';
import 'dart:convert';
import 'dart:io';

import 'package:flutter_aadhaar_xml_sdk/IosAadhaarModel.dart';

import 'AndroidAadhaarModel.dart';

import 'package:flutter/services.dart';

/// Provides information stored in aadhaar xml.
class FlutterAadhaarXmlSdk {
  static const MethodChannel _channel =
      const MethodChannel('flutter_aadhaar_xml_sdk');

  /// To inovke sdk call this method from dart file.
  /// pass appropriate parameters such as token, env and client
  /// @token : token obtained from jwt  ( you can follow documentation shared by bd team to generate this token.
  /// @env : pass 'test' in sandbox mode and 'prod' in production mode
  /// @client : client id will  be shared by bd team
  static Future<dynamic> startSdk(
      String token, String env, String client) async {
    /// platform check for android
    if (Platform.isAndroid) {
      return AndroidAadhaarModel.fromMap(await _channel.invokeMethod(
              'startSdk', {"token": token, "env": env, "client": client}) ??
          <String, dynamic>{});
    }

    /// platform check for ios
    else if (Platform.isIOS) {
      return IosAadhaarModel.fromMap(await _channel.invokeMethod(
              'startSdk', {"token": token, "env": env, "client": client}) ??
          <String, dynamic>{});
    }
  }
}
